/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/



//  tboEnemyBigBoss.m

#import "tboEnemyBigBoss.h"


@implementation tboEnemyBigBoss

	// initObject
	- (void) initObject
	{
		[super initObject];
		
		// typeId
		typeId=2;
		
		// size ...
		// bigger ...
		[self setSize:NSMakePoint(60,60)];
		
		// check if there is enough space
		// > shrink
		
		// ------------
		// size 
		// ------------
		// min
		minSizeX=10;
		minSizeY=10;
		
		// max
		maxSizeX=60;
		maxSizeY=60;
		
		// max Playfield
		playFieldCountX=400;
		playFieldCountY=400;
		
		// period
		period=0;
	}
	
	
	
	// ...
	- (void) doThread: (int[420][420]) tf
	{
		// doThread
		[super doThread:tf];

		// period ..
		--period;
		if (period<0)
		 period=6000;
		 
	}


	// move
	
	// --------------
	// move
	// --------------
	- (void) move:(int[420][420]) tf
	{
						
		// do Move ..
		if (period>1000)
		 [self doMove:tf];
	
		// slow down
		if (period>0)
		{
			if (period<1100) 
			{
			 if (period%10==0)
				[self doMove:tf];
			}
			else
			if (period<1300) 
			{
			  if (period%5==0)
				[self doMove:tf];
			}
		}
			
	}
	
		// doShoot
		- (BOOL) doShoot
		{
			BOOL retF=false;
			
			// do it ...
			if (period==4) 
			   retF=true;
			   
			// sub 
			--period;
			
			return retF;
		}
	
		// doMove
		- (void) doMove:(int[420][420]) tf
		{
			
			// do move bounce
			[self doMoveBounce:tf];
			
		}
		
		
		// doResize
		- (int) doResize:(int[420][420]) tf
		{
		   int maxSize=0;
		   
		   
		   int startx=(int) location.x;
		   int starty=(int) location.y;
		   int stopx=startx+(int) size.x;
		   int stopy=starty+(int) size.y;
		   
		   int o=0;
		   
		   // ok let's check
		   int t=0;
		   for (t=0;t<300;++t)
		   {
				++maxSize;
				
				// make bigger
				--startx;
				--starty;
				++stopx;
				++stopy;
				
				BOOL stopCheck=false;
				
				// frame
				if (startx<0)
				  startx=0;
				if (starty<0)
				  starty=0;if (stopx>playFieldCountX)
				  stopx=playFieldCountX-1;
				if (stopy>playFieldCountY)
				  stopy=playFieldCountY-1;
				
				  
				
				// ***
				// ---
				for (o=startx;o<stopx;++o)
				{
					// free ..
					if (tf[o][starty]!=0)
					{
						stopCheck=true;
						break;
					}
				}	
				
				// ---
				// ***
				for (o=startx;o<stopx;++o)
				{
					// free ..
					if (tf[o][stopy]!=0)
					{
						stopCheck=true;
						break;
					}
				}	
				
				if (stopCheck)
				 break;
				
		   }
		   
		   NSLog(@"tboEnemyBigBoss.doResize()=%d",maxSize);
		   return maxSize;
		}
		
		// do resize
		- (void) resizeIt:(int) sizeit
		{
			// max & min
			if ((size.x+sizeit)>maxSizeX)
			{
				size.x=maxSizeX;
			}
			if ((size.y+sizeit)>maxSizeY)
			{
				size.y=maxSizeY;
			}
			
			// min
			if ((size.x+sizeit)<minSizeX)
			{
				size.x=maxSizeX;
			}
			if ((size.y+sizeit)<minSizeY)
			{
				size.y=maxSizeY;
			}
			
			location.x=location.x-sizeit/2;
			location.y=location.y-sizeit/2;
			size.x=size.x+sizeit/2;
			size.y=size.y+sizeit/2;
			
		}
	
@end
