/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/


//  tboOnFire.m

#import "tboOnFire.h"
#import "tboEnemy.h"

@implementation tboOnFire

	// initObject
	- (void) initObject
	{
		[super initObject];
		
		// fire runner
		typeId=5;
		
		// type
		directionType=1;
		
		// runner counter
		runCounter=0;
		
		// reset the runner
		[self resetRunner];
		
	}
	
		- (void) resetRunner
		{
					// hunt direction
					huntDirectionX=1;
					huntDirectionY=0;
					huntDirectionXHis=0;
					huntDirectionYHis=0;
		
					status=0;
		}
	
	// faster
	// -------------------------
// doThread
// -------------------------
// 
- (void) doThread: (int[420][420]) tf
{
	// do Thread
	[super doThread:tf];
	
	
	++runCounter;
	if (runCounter>2)
	{
		runCounter=0;
		
		// and again
		[self move:tf];
	}
	
	// NSLog(@"tboFire.doThread[%d]",status);
}

	// setDirectionType
	- (void) setDirectionType:(int) newtype
	{
		directionType=newtype;
	}
	
	// --------------
	// move
	// --------------
	- (void) move:(int[420][420]) tf
	{
	
		// activ ?
		if (status==3)
		{
	
			// NSLog(@"tbOnFire.move(%d,%d)",huntDirectionX,huntDirectionY);
			
			int locx=(int) location.x;
			int locy=(int) location.y;
			
			
			
				if (tf[locx+huntDirectionX][locy+huntDirectionY]!=3)
				{
					// end ? secure line ?
					if (tf[locx+huntDirectionX][locy+huntDirectionY]==2)
					{
						[self resetRunner];
						status=0;
						// NSLog(@"tboOnFire.move:endSecureLine");
					}
					
					huntDirectionXHis=huntDirectionX;
					huntDirectionYHis=huntDirectionY;
				
					// on the hunt ..
					huntDirectionX=0;
					huntDirectionY=0;
					
					
					// left preferred
					if (directionType==-1)
					{
						
						if ((huntDirectionXHis!=-1) && (huntDirectionYHis!=0))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goLeft:tf];
						if ((huntDirectionXHis!=0) && (huntDirectionYHis!=-1))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goUp:tf];
						
						if ((huntDirectionXHis!=1) && (huntDirectionYHis!=0))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goRight:tf];
						if ((huntDirectionXHis!=0) && (huntDirectionYHis!=1))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goDown:tf];
					}
					
					// right preferred
					if (directionType==1)
					{
						if ((huntDirectionXHis!=1) && (huntDirectionYHis!=0))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goRight:tf];
						if ((huntDirectionXHis!=0) && (huntDirectionYHis!=1))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goDown:tf];
						if ((huntDirectionXHis!=-1) && (huntDirectionYHis!=0))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goLeft:tf];
						if ((huntDirectionXHis!=0) && (huntDirectionYHis!=-1))
							if ((huntDirectionX==0) && (huntDirectionY==0)) [self goUp:tf];
						
					}
					
					// no exit found 
					
					if ((huntDirectionX==0) && (huntDirectionY==0))
					{
						huntDirectionX=huntDirectionXHis;
						huntDirectionY=huntDirectionYHis;
					}
					
				}
				else
				{
					locx=locx+huntDirectionX;
					locy=locy+huntDirectionY;
				}
			
			
			
			// store
			location.x=locx;
			location.y=locy;
		}
		
	}
			- (void) goLeft:(int[420][420]) tf
			{
				int locx=(int) location.x;
				int locy=(int) location.y;
			
				if (tf[locx-1][locy]==3)
				{
					huntDirectionX=-1;
				}
			}
			- (void) goRight:(int[420][420]) tf
			{
				int locx=(int) location.x;
				int locy=(int) location.y;
			
				if (tf[locx+1][locy]==3)
				{
					huntDirectionX=1;
				}
			}
			- (void) goUp:(int[420][420]) tf
			{
				// NSLog(@"tboOnFire.goUp");
				
				int locx=(int) location.x;
				int locy=(int) location.y;
			
				if (tf[locx][locy-1]==3)
				{
					huntDirectionY=-1;
				}
			}
			- (void) goDown:(int[420][420]) tf
			{
				int locx=(int) location.x;
				int locy=(int) location.y;
			
				if (tf[locx][locy+1]==3)
				{
					huntDirectionY=1;
				}
			}
	
@end
