/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/


//  objectWall.m

#import "objectWall.h"


@implementation objectWall

// initObject
- (void) initObject
{
	wallTypeId=1;
	// 1 - normal wall (active wall)
	// 2 - fire line (in enemy's land)
	// 3 - going down wall (old normal wall)
	
	flatNumber=0;
	
	// position
	leftCorner=NSMakePoint(0,0);
	z=0;
	rightCorner=NSMakePoint(1,1);
	zz=1;

	// usedWall
	inUse=true;
	
	// vertical ...
	bVertical=true;
}

// ------------------------------
// wallTypeId
// ------------------------------
// wallTypeId
- (int) wallTypeId
{
	return wallTypeId;
}

// setWallTypeId
- (void) setWallTypeId: (int)newid
{
	wallTypeId=newid;
}

// ------------------------
// vertical
// ------------------------
// vertical
- (BOOL) vertical
{
	return bVertical;
}

// setVertical
- (void) setVertical: (BOOL)newid
{
	bVertical=newid;
}

// ------------------------------
// flatNumber
// ------------------------------
// flatNumber
- (int) flatNumber
{
	return flatNumber;
}

// setFlatNumber
- (void) setFlatNumber: (int)nflatnumber
{
	flatNumber=nflatnumber;
}


// ----------------
// position
// ----------------

// leftCorner
- (NSPoint) leftCorner
{
	return leftCorner;
}

// setLeftCorner
- (void) setLeftCorner: (NSPoint) argPoint
{
	leftCorner.x=argPoint.x;
	leftCorner.y=argPoint.y;
}

// getRightCorner
- (NSPoint) rightCorner
{
	return rightCorner;
}

// setRightCorner
- (void) setRightCorner: (NSPoint) argPoint
{
	rightCorner.x=argPoint.x;
	rightCorner.y=argPoint.y;
}

// -----------------
// z
// -----------------
- (int) z
{
	return z;
}

// setZ
- (void) setZ:(int)iz
{
	z=iz;
}


// -----------------
// zz
// -----------------
- (int) zz
{
	return zz;
}

// setZZ
- (void) setZZ:(int)iz
{
	zz=iz;
}

// -----------------
// in use
// -----------------
// inUse
- (BOOL) inUse
{
	return inUse;
}
// setInUse
- (BOOL) setInUse: (BOOL) flag
{
	inUse=flag;
}

@end
