/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/

//  tpObject.h

#import <Foundation/Foundation.h>


@interface tpObject : NSObject 
{
	// type [|enemy|extra]
	int typeId;
	// typeIdSub
	int typeIdSub;
	
	NSMutableString * objectType;
	
	// location
	NSPoint location;
	float posZ;

	// size
	NSPoint size;
	
	// direction
	NSPoint direction;
	
	// representation
    // status
	BOOL onSecretLine;
	
	// possible to create new line
	// status ... 
	BOOL avalaibleOffLine;
	
	int status;
	// 0 inactiv
	// 1 will be destroyed
	// 2 coming in
	// 3 activ
	
	// timer
	float timer;
	float timerMax;
	
	// animation
	int animationCounter;
	
	
	// is flying or inline ?
	BOOL flyingFlag;
	
	// system
	
	
}

// init / reset
- (void) initObject;


// type
- (NSMutableString *) getType;
- (void) setType:(NSString *) string;

// typeid
- (int) typeId;
// getTypeId
- (int) getTypeId;
// setTypeId
- (void) setTypeId:(int) itypeid;

// -------------------------
// typeSub
// -------------------------
- (int) typeSub;
// setTypeId
- (void) setTypeIdSub:(int) itypeid;

// position
- (NSPoint) getPosition;
- (void) setPosition:(NSPoint) p;

// --------------------------------
// timer
// --------------------------------
// timer
- (float) timer;
// setTimer
- (void) setTimer:(float) itimer;

// timerMax
- (float) timerMax;
// setTimer
- (void) setTimerMax:(float) itimer;

// -------------------------
// status
// -------------------------
- (int) status;

// -------------------------
// size
// -------------------------
// size
- (NSPoint) size;
// setSize
- (void) setSize:(NSPoint) p;

// secret line
- (BOOL) secretLine;
- (BOOL) setSecretLine: (BOOL) status;

// avaibleOffLine
- (BOOL) avaibleOffLine;
- (BOOL) setAvaibleOffLine: (BOOL) status;

// -------------------------
// object thread
// -------------------------
-(void) move:(int[420][420]) tf;


// flying



// setFlyingFlag
- (BOOL) setFlyingFlag:(BOOL) iflyingFlag;
// flyingFlag
- (BOOL) flyingFlag;


// -------------------------
// direction
// -------------------------
// 
- (NSPoint) direction;

// setDirection
- (void) setDirection:(NSPoint) p;


// inLiberatedLand
- (BOOL) inLiberatedLand:(int[420][420]) tf;

@end
