
/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/


//  tpObject.m

#import "tpObject.h"


@implementation tpObject

// initObject
- (void) initObject
{
	// typeId
	typeId=1;
	
	// 1 representation
	// 2 enemyBoss
	// 3 bonus
	
	// 4 enemy
	// 5 firerunner
	
	// 6 enemy
	
	
	// 7 animation
	
	// sub objects
	typeIdSub=0;
	
	// on a secret line ?
	onSecretLine=true;
	
	// avalaible create line
	avalaibleOffLine=false;
	
	// type
	objectType=[NSMutableString alloc] ;
	[objectType initWithFormat:@"%@",@"representation"];

	// position
	location= NSMakePoint(0, 0);
	
	// size
	size= NSMakePoint(10, 10);
	
	// direction
	direction=NSMakePoint(0.3f,0.2f);
	
	posZ=0.0f;

    // activ
	status=3;

	// timer
	timer=0.0f;
	timerMax=10.0f;
	
	
	// animation
	animationCounter=0;
	
	 
	 // flying
	 flyingFlag=false;
}

// -------------------------
// doThread
// -------------------------
// 
- (void) doThread: (int[320][320]) tf
{
		
	
}

// contactPlayField
- (void) doContactPlayField: (int[320][320]) tf
{
	
}

// contactObjects


// -------------------------
// type
// -------------------------
- (int) typeId
{
	return typeId;
}
// getTypeId
- (int) getTypeId
{
	return typeId;
}
// setTypeId
- (void) setTypeId:(int) itypeid
{
	typeId=itypeid;
}

// -------------------------
// typeSub
// -------------------------
- (int) typeSub
{
	return typeIdSub;
}
// setTypeId
- (void) setTypeIdSub:(int) itypeid
{
	typeIdSub=itypeid;
}


// getType
- (NSMutableString *) getType
{
	return objectType;
}

// setType
- (void) setType:(NSString *) string
{
	[objectType initWithFormat:@"%@",string];
	// [objectType setString:string];
}


// --------------------------------
// timer
// --------------------------------
// timer
- (float) timer
{
	return timer;
}
// setTimer
- (void) setTimer:(float) itimer
{
	timer=itimer;
}

// timer
- (float) timerMax
{
	return timerMax;
}
// setTimer
- (void) setTimerMax:(float) itimer
{
	timerMax=itimer;
}


// -------------------------
// position
// -------------------------
// getPosition
- (NSPoint) getPosition
{
	return NSMakePoint((int)location.x,(int) location.y);
}

// setPositionX
- (void) setPosition:(NSPoint) p
{
	location.x=p.x;
	location.y=p.y;
}

// -------------------------
// direction
// -------------------------
// 
- (NSPoint) direction
{
	return NSMakePoint((int)direction.x,(int) direction.y);
}

// setDirection
- (void) setDirection:(NSPoint) p
{
	direction.x=p.x;
	direction.y=p.y;
}

// -------------------------
// size
// -------------------------
// size
- (NSPoint) size
{
	return NSMakePoint((int)size.x,(int) size.y);
}

// setSize
- (void) setSize:(NSPoint) p
{
	size.x=p.x;
	size.y=p.y;
}


// status
- (int) status
{
	return status;
}

// status
- (void) setStatus:(int) istatus
{
	status=istatus;
}


// --------------
// move
// --------------
-(void) move: (int[420][420]) tf
{


}




// -------------------------
// secret Line
// -------------------------
- (BOOL) secretLine
{
	return onSecretLine;
}

- (BOOL) setSecretLine: (BOOL) status
{
	onSecretLine=status;
}
	
// -------------------------
// avalaibleOffLine
// -------------------------
- (BOOL) avaibleOffLine
{
	return avalaibleOffLine;
}

- (BOOL) setAvaibleOffLine: (BOOL) status
{
	avalaibleOffLine=status;
}

	// -------------
	// flying 
	// -------------
	
	// setFlyingFlag
	- (BOOL) setFlyingFlag:(BOOL) iflyingFlag
	{
		flyingFlag=iflyingFlag;
	}
	// flyingFlag
	- (BOOL) flyingFlag
	{
		return flyingFlag;
	}

	// --------------------
	// inLiberatedLand
	// --------------------
	- (BOOL) inLiberatedLand:(int[420][420]) tf
	{
		BOOL inLib=false;
		
		// oh lets go out ..
		if (
			 (tf[(int) location.x+((int) size.x)/2][(int) location.y+((int) size.y)/2]==1)
			 ||
			 (tf[(int) location.x+((int) size.x)/2][(int) location.y+((int) size.y)/2]==2)
			)
		{
			// do suicide
			if (!flyingFlag) // if not flying over all ..
			{ 
			   // status=0;
			   inLib=true;
			}
		}
		
		return inLib;
	
	}

	
@end
